---
title: Logical nullish assignment (??=)
slug: Web/JavaScript/Reference/Operators/Logical_nullish_assignment
tags:
  - Assignment operator
  - JavaScript
  - Language feature
  - Logical Operator
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p>The logical nullish assignment (<code>x ??= y</code>) operator only assigns if <code>x</code> is {{Glossary("nullish")}} (<code>null</code> or <code>undefined</code>).</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-logical-nullish-assignment.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>expr1</em> ??= <em>expr2</em>
</pre>

<h2 id="Description">Description</h2>

<h3 id="Short-circuit_evaluation">Short-circuit evaluation</h3>

<p>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Nullish_coalescing_operator">nullish coalescing</a> operator is evaluated left to right, it is tested for possible short-circuit evaluation using the following rule:</p>

<p><code>(some expression that is neither null nor undefined) ?? expr</code> is short-circuit evaluated to the left-hand side expression if the left-hand side proves to be neither <code>null</code> nor <code>undefined</code>.</p>

<p>Short circuit means that the <code><em>expr</em></code> part above is <strong>not evaluated</strong>, hence any side effects of doing so do not take effect (e.g., if <code><em>expr</em></code> is a function call, the calling never takes place).</p>

<p>Logical nullish assignment short-circuits as well meaning that <code>x ??= y</code> is equivalent to:</p>

<pre class="brush: js notranslate">x ?? (x = y);</pre>

<p>And not equivalent to the following which would always perform an assignment:</p>

<pre class="brush: js notranslate example-bad">x = x ?? y;
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_logical_nullish_assignment">Using logical nullish assignment</h3>

<pre class="brush: js notranslate">function config(options) {
  options.duration ??= 100;
  options.speed ??= 25;
  return options;
}

config({ duration: 125 }); // { duration: 125, speed: 25 }
config({}); // { duration: 100, speed: 25 }
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
  </tr>
  <tr>
   <td>{{SpecName('Logical Assignment', '#sec-assignment-operators', 'Assignment operators')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.logical_nullish_assignment")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Nullish_coalescing_operator">The nullish coalescing operator (<code>??</code>)</a></li>
 <li>{{Glossary("Nullish")}}</li>
 <li>{{Glossary("Truthy")}}</li>
 <li>{{Glossary("Falsy")}}</li>
</ul>
